package foo.bar.impl;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

import foo.bar.CGIConf;
import foo.bar.CGIRunner;

public class CGIConfImpl implements CGIConf {

	private String prefix = null;

	private Properties config = null;

	public CGIConfImpl(String filename, String prefix) throws IOException {
		this.prefix = (prefix != null) ? prefix : "";

		InputStream in = null;

		try {
			ClassLoader loader = Thread.currentThread().getContextClassLoader();

			if (loader == null) {
				loader = this.getClass().getClassLoader();
			}

			in = loader.getResourceAsStream(filename);

			config = new Properties();
			config.load(in);
		} finally {
			if (in != null) {
				in.close();
			}
		}
	}

	public CGIRunner getRunner() {
		try {
			String className = config.getProperty(prefix + "runner");
			Class clazz = Class.forName(className);
			CGIRunner loader = (CGIRunner) clazz.newInstance();
			return loader;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	public String getEncoding() {
		return config.getProperty(prefix + "encoding");
	}

}