package foo.bar.impl;

import java.io.PrintWriter;
import java.util.Iterator;
import java.util.Map;

import foo.bar.CGIConf;
import foo.bar.CGIRunner;

public class SampleRunner implements CGIRunner {

	private CGIConf config = null;

	private String extPath = null;

	private Map params = null;

	public void setConfig(CGIConf config) {
		this.config = config;
	}

	public void setExtendedPath(String extPath) {
		this.extPath = extPath;
	}

	public void setParams(Map params) {
		this.params = params;
	}

	public void run(PrintWriter writer) {
		writer.println("<html>");
		writer.println("  <head>");
		writer.println("    <title>hello, Java/CGI</title>");
		writer.println("  </head>");
		writer.println("  <body>");
		writer.println("    hello, Java/CGI");
		writer.println("    <hr>");
		writer.println("    <table border=\"1\">");
		writer.println("      <tr>");
		writer.println("        <th colspan=\"2\">Configurations("
				+ config.getClass().getName() + ")</th>");
		writer.println("      </tr>");
		writer.println("      <tr>");
		writer.println("        <th>Runner</th>");
		writer.println("        <td>" + config.getRunner().getClass().getName()
				+ "</td>");
		writer.println("      </tr>");
		writer.println("      <tr>");
		writer.println("        <th>Encoding</th>");
		writer.println("        <td>" + config.getEncoding() + "</td>");
		writer.println("      </tr>");
		writer.println("    </table>");
		writer.println("    <br>");
		writer.println("    <table border=\"1\">");
		writer.println("      <tr>");
		writer.println("        <th>Extended path</th>");
		writer.println("      </tr>");
		writer.println("      <tr>");

		if (extPath != null && !extPath.equals("")) {
			writer.println("        <td>" + extPath + "</td>");
		} else {
			writer.println("        <td>empty.</td>");
		}

		writer.println("      </tr>");
		writer.println("    </table>");
		writer.println("    <br>");
		writer.println("    <table border=\"1\">");
		writer.println("      <tr>");
		writer.println("        <th colspan=\"2\">Parameters</th>");
		writer.println("      </tr>");

		if (params.size() > 0) {
			Iterator ite = params.keySet().iterator();

			while (ite.hasNext()) {
				String name = (String) ite.next();
				Object value = params.get(name);
				writer.println("      <tr>");
				writer.println("        <th>" + name + "</th>");
				writer.println("        <td>" + value + "</td>");
				writer.println("      </tr>");
			}
		} else {
			writer.println("      <tr>");
			writer.println("        <td colspan=\"2\">empty.</td>");
			writer.println("      </tr>");
		}

		writer.println("    </table>");
		writer.println("  </body>");
		writer.println("</html>");
	}

}